#include "stdafx.h"
#include "RemMFC.h"
#include "ColorStatic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CColorStatic
CColorStatic::CColorStatic()
{
	m_Text = "";
	m_clText = RGB(0,0,0);
	m_clBack = GetBackColor();
	m_clbkText = m_clBack;
	memset(&m_logfont, 0, sizeof(m_logfont));
	memset(&m_rc, 0, sizeof(m_rc));
}
//---------------------------------------------------------------------------
CColorStatic::~CColorStatic()
{
}


BEGIN_MESSAGE_MAP(CColorStatic, CStatic)
	//{{AFX_MSG_MAP(CColorStatic)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
void CColorStatic::OnPaint() 
{
	if( !IsWindowVisible() ) return;

	CPaintDC dc(this);
	OnDraw(&dc);
}
//---------------------------------------------------------------------------
void CColorStatic::SetWindowText(LPCSTR pText, COLORREF col)
{
	m_Text = pText;
	m_clbkText = col;
	if( !m_hWnd || !IsWindowVisible() ) return;

	CClientDC dc(this);
	OnDraw(&dc);
}
//---------------------------------------------------------------------------
void CColorStatic::OnDraw(CDC *pDC)
{
	ASSERT(pDC);

	if( !m_logfont.lfWeight ) GetFont()->GetLogFont(&m_logfont);
	if( !m_rc.bottom ) GetClientRect(&m_rc);

	pDC->FillSolidRect(&m_rc, m_clBack);

	pDC->SetBkColor(m_clbkText);
	pDC->SetTextColor(m_clText);

	CFont font;
	font.CreateFontIndirect(&m_logfont);
	CFont *pOldFont = pDC->SelectObject(&font);
	pDC->DrawText(m_Text, &m_rc, DT_SINGLELINE );
	pDC->SelectObject(pOldFont);
	font.DeleteObject();
}

