// TButton.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "RemMFC.h"
#include "RemMFCDlg.h"
#include "TButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CToggleButton    JX^Rg[

IMPLEMENT_DYNAMIC(CToggleButton, CButton)

CToggleButton::CToggleButton()
{
	m_Enabled = TRUE;
	m_Toggled = TRUE;
	m_pDlg = NULL;
	m_nID = 0;
	m_clEdge[0] = GetSysColor(COLOR_BTNHILIGHT);
	m_clEdge[1] = GetSysColor(COLOR_BTNSHADOW);
	m_clEdge[2] = GetSysColor(COLOR_3DDKSHADOW);
	m_clFace = GetSysColor(COLOR_BTNFACE);
	m_clPush = RGB(255,255,255);
	m_fState = FALSE;
	m_clText = RGB(0,0,0);
	m_clGrayText = GetSysColor(COLOR_GRAYTEXT);
	memset(&m_rcClient, 0, sizeof(m_rcClient));
}

CToggleButton::~CToggleButton()
{
}


BEGIN_MESSAGE_MAP(CToggleButton, CButton)
	//{{AFX_MSG_MAP(CToggleButton)
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CToggleButton
//---------------------------------------------------------------------------
void CToggleButton::InitialUpdate(CRemMFCDlg *pDlg)
{
	m_pDlg = pDlg;
	GetClientRect(&m_rcClient);
	CButton::GetWindowText(m_Text);
	m_Enabled = CButton::IsWindowEnabled();
	if( !m_Enabled ){
		CButton::EnableWindow(TRUE);
	}
	m_nID = GetDlgCtrlID();
}
//---------------------------------------------------------------------------
void CToggleButton::Initialize(void)
{
	if( !m_rcClient.right ) InitialUpdate(NULL);
}
//---------------------------------------------------------------------------
void CToggleButton::Draw(void)
{
	if( !IsWindowVisible() ) return;
	CClientDC dc(this);
	OnDraw(&dc);
}
//---------------------------------------------------------------------------
void CToggleButton::SetState(BOOL bHighlight)
{
	Initialize();
	if( m_fState == bHighlight ) return;
	m_fState = bHighlight;
	Draw();
}
//---------------------------------------------------------------------------
void CToggleButton::SetWindowText(LPCTSTR lpszString)
{
	Initialize();
	if( strcmp(m_Text, lpszString) ){
		m_Text = lpszString;
		Draw();
	}
}
//---------------------------------------------------------------------------
void CToggleButton::GetWindowText(CString& rString) const
{
	rString = m_Text;
}
//---------------------------------------------------------------------------
void CToggleButton::EnableWindow(BOOL bEnable)
{
	Initialize();
	if( bEnable != m_Enabled ){
		m_Enabled = bEnable;
		Draw();
	}
}
//---------------------------------------------------------------------------
void CToggleButton::OnPaint() 
{
	CPaintDC dc(this);
	OnDraw(&dc);
}
//---------------------------------------------------------------------------
void CToggleButton::OnDraw(CDC *pDC)
{
	Initialize();

	RECT rc = m_rcClient;
	pDC->FillSolidRect(&rc, m_clEdge[2]);
	if( m_fState ){		// push button
		rc.top++; rc.left++;
		pDC->FillSolidRect(&rc, m_clEdge[1]);
		rc.top++; rc.left++;
		pDC->FillSolidRect(&rc, m_clEdge[0]);
		rc.bottom--; rc.right--;
		pDC->FillSolidRect(&rc, m_clPush);
	}
	else {				// pop button
		rc.bottom--; rc.right--;
		pDC->FillSolidRect(&rc, m_clEdge[1]);
		rc.bottom--; rc.right--;
		pDC->FillSolidRect(&rc, m_clEdge[0]);
		rc.top++; rc.left++;
		pDC->FillSolidRect(&rc, m_clFace);
	}
	CFont *pOldFont = pDC->SelectObject(GetFont());
	pDC->SetTextColor(m_Enabled ? m_clText : m_clGrayText);
	pDC->DrawText(m_Text, &rc, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
	pDC->SelectObject(pOldFont);
}
//---------------------------------------------------------------------------
void CToggleButton::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if( !m_Enabled ) return;
	if( m_Toggled ){
		SetState(!GetState());
	}
	else {
		SetState(TRUE);
		::Sleep(100);
		SetState(FALSE);
	}
	if( m_nID ){
		GetParent()->SendMessage(WM_COMMAND, MAKELONG(m_nID, BN_CLICKED), (DWORD)m_hWnd);
	}
}
void CToggleButton::OnLButtonUp(UINT nFlags, CPoint point) 
{
}
void CToggleButton::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
}
//---------------------------------------------------------------------------
void CToggleButton::OnRButtonDown(UINT nFlags, CPoint point) 
{
	if( m_pDlg && m_Enabled ) m_pDlg->OnToggleRClick(this);
	CButton::OnRButtonDown(nFlags, point);
}
